Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.flagstone.transform
Class FSJPEGEncodingTable

    java.lang.Object
      com.flagstone.transform.FSTransformObject
          com.flagstone.transform.FSMovieObject
              com.flagstone.transform.FSJPEGEncodingTable

All Implemented Interfaces:
  java.lang.Cloneable

    public class FSJPEGEncodingTable

extends FSMovieObject

FSJPEGEncodingTable defines an encoding table for JPEG images.

The encoding table is shared between all images defined using the FSDefineJPEGImage class so there should only be one FSJPEGEncodingTable object defined in a movie.

Attributes
type | Identifies the data structure when it is encoded. Read-only.
encodingTable | An array of bytes containing the encoding table data.

The FSJPEGEncodingTable class is not essential to define JPEG encoded images in a movie using the FSDefineJPEGImage class. If an FSJPEGEncodingTable object is created with an empty encoding table then the Flash Player will still display JPEG images defined using FSDefineJPEGImage objects correctly. When an FSJPEGEncodingTable with an empty encoding table is encoded to a Flash file, the "end of stream" marker 0xFFD9 is encoded allowing the empty table to be decoded correctly.

# Examples

The simplest way to use the FSJPEGEncodingTable and FSDefineJPEGImage classes to define JPEG encoded images is to create an empty encoding table then construct the FSDefineJPEGImage object(s) with the image data from a file:

     File aFile = new File(filename);
     byte[] bytes = new byte[(int) aFile.length()];

     try
     {
            FileInputStream imageContents = new FileInputStream(aFile);
            imageContents.read(bytes);
            imageContents.close();
     } catch (FileNotFoundException e)
     {
            throw new FileNotFoundException(filename);
     } catch (IOException e)
     {
            throw new IOException(filename);
     }

     movie.add(new FSJPEGEncodingTable());
     movie.add(new FSDefineJPEGImage(movie.newIdentifier(), bytes));

# History

The FSJPEGEncodingTable class represents the JPEGEncodingTable tag from the Macromedia Flash (SWF) File Format Specification. It was introduced in Flash 1.

Field Summary

Fields inherited from class com.flagstone.transform.FSMovieObject
`ButtonColorTransform, ButtonSound, DefineBitsPtr, DefineButton, DefineButton2, DefineFont, DefineFont2, DefineImage, DefineImage2, DefineJPEGImage, DefineJPEGImage2, DefineJPEGImage3, DefineMorphShape, DefineMovieClip, DefineShape, DefineShape2, DefineShape3, DefineSound, DefineText, DefineText2, DefineTextField, DefineVideo, DoAction, EnableDebugger, EnableDebugger2, Export, extendLength, FontInfo, FontInfo2, FrameLabel, Free, Import, Initialize, JPEGTables, length, LimitScript, PathsArePostscript, PlaceObject, PlaceObject2, Protect, QuicktimeMovie, RemoveObject, RemoveObject2, SerialNumber, SetBackgroundColor, ShowFrame, SoundStreamBlock, SoundStreamHead, SoundStreamHead2, StartSound, TabOrder, type, VideoFrame`

Constructor Summary
`FSJPEGEncodingTable()` Constructs an FSJPEGEncodingTable object with an empty encoding table.
`FSJPEGEncodingTable(byte[] bytes)` Constructs an FSJPEGEncodingTable object with the encoding table data.
`FSJPEGEncodingTable(FSCoder coder)` Construct an FSJPEGEncodingTable object, initalizing it with values decoded from an encoded object.
`FSJPEGEncodingTable(FSJPEGEncodingTable obj)` Constructs an FSJPEGEncodingTable object by copying values from an existing object.

Method Summary
`void` | `appendDescription(java.lang.StringBuffer buffer, int depth)` AppendDescription is used to present a string description of the object including all nested objects up to a specified depth.
`java.lang.Object` | `clone()` Creates a deep copy of the entire object.
`void` | `decode(FSCoder coder)`
`void` | `encode(FSCoder coder)`
`boolean` | `equals(java.lang.Object anObject)` Returns true if anObject is equal to this one.
`byte[]` | `getEncodingTable()` Gets the encoding table.
`int` | `length(FSCoder coder)`
`void` | `setEncodingTable(byte[] bytes)` Sets the encoding table.

Methods inherited from class com.flagstone.transform.FSMovieObject
`getType`

Methods inherited from class com.flagstone.transform.FSTransformObject
`name, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FSJPEGEncodingTable

    public FSJPEGEncodingTable(FSCoder coder)

  Construct an FSJPEGEncodingTable object, initalizing it with values decoded from an encoded object.

  Parameters:
    `coder` - an FSCoder containing the binary data.

### FSJPEGEncodingTable

    public FSJPEGEncodingTable()

  Constructs an FSJPEGEncodingTable object with an empty encoding table.

### FSJPEGEncodingTable

    public FSJPEGEncodingTable(byte[] bytes)

  Constructs an FSJPEGEncodingTable object with the encoding table data.

  Parameters:
    `bytes` - an array of bytes contains the data for the encoding table.

### FSJPEGEncodingTable

    public FSJPEGEncodingTable(FSJPEGEncodingTable obj)

  Constructs an FSJPEGEncodingTable object by copying values from an existing object.

  Parameters:
    `obj` - an FSJPEGEncodingTable object.

Method Detail

### getEncodingTable

    public byte[] getEncodingTable()

  Gets the encoding table.

  Returns:
    the array of bytes contains the data for the encoding table.

### setEncodingTable

    public void setEncodingTable(byte[] bytes)

  Sets the encoding table.

  Parameters:
    `bytes` - an array of bytes contains the data for the encoding table.

### clone

    public java.lang.Object clone()

  Description copied from class: `FSTransformObject`
  Creates a deep copy of the entire object.

  Overrides:
    `clone` in class `FSTransformObject`
  Returns:
    a copy of the object.

### equals

    public boolean equals(java.lang.Object anObject)

  Description copied from class: `FSMovieObject`
  Returns true if anObject is equal to this one. Objects are considered equal if they would generate identical binary data when they are encoded to a Flash file.

  Overrides:
    `equals` in class `FSMovieObject`
  Returns:
    true if this object would be identical to anObject when encoded.

### appendDescription

    public void appendDescription(java.lang.StringBuffer buffer,
                                  int depth)

  Description copied from class: `FSTransformObject`
  AppendDescription is used to present a string description of the object including all nested objects up to a specified depth. This method provide a more controlled way of creating a string representation of an object since large objects such as font or shape definitions can contain dozens of nested objects. The representation of the object is appended to the StringBuffer, showing the name of the class and values of the attributes it contains. If the object contains any attributes that are objects then the object graph will be traversed up to the specified depth. If objects are nested at a level less than specified depth then the full string representation of the object is displayed. For objects at the specified depth only the name of the class is displayed. Any objects below this depth are not displayed.

  Overrides:
    `appendDescription` in class `FSMovieObject`
  Parameters:
    `buffer` - a StringBuffer to which the description of each object is appended.
    `depth` - the maximum level of nesting up to which objects will be displayed.

### length

    public int length(FSCoder coder)

  Overrides:
    `length` in class `FSMovieObject`

### encode

    public void encode(FSCoder coder)

  Overrides:
    `encode` in class `FSMovieObject`

### decode

    public void decode(FSCoder coder)

  Overrides:
    `decode` in class `FSMovieObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD